The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::TcpServer Class Reference

STK TCP socket server class. More...

`#include <TcpServer.h>`

Inheritance diagram for stk::TcpServer:

## Public Member Functions
| TcpServer (int port=2006)
| Default constructor creates a local socket server on port 2006 (or the specified port number). More...
| ~TcpServer ()
| The class destructor closes the socket instance, breaking any existing connections.
int | accept (void)
| Extract the first pending connection request from the queue and create a new connection, returning the descriptor for the accepted socket. More...
int | writeBuffer (const void *buffer, long bufferSize, int flags=0)
| Write a buffer over the socket connection. Returns the number of bytes written or -1 if an error occurs.
int | readBuffer (void *buffer, long bufferSize, int flags=0)
| Read a buffer from the socket connection, up to length bufferSize. Returns the number of bytes read or -1 if an error occurs.
Public Member Functions inherited from stk::Socket
| Socket ()
| Class constructor.
virtual | ~Socket ()
| Class destructor.
int | id (void) const
| Return the socket descriptor.
int | port (void) const
| Return the socket port number.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Socket
static void | close (int socket)
| Close the socket.
static bool | isValid (int socket)
| Returns true if the socket descriptor is valid.
static void | setBlocking (int socket, bool enable)
| If enable = false, the socket is set to non-blocking mode. When first created, sockets are by default in blocking mode.
static int | writeBuffer (int socket, const void *buffer, long bufferSize, int flags)
| Write a buffer via the specified socket. Returns the number of bytes written or -1 if an error occurs.
static int | readBuffer (int socket, void *buffer, long bufferSize, int flags)
| Read a buffer via the specified socket. Returns the number of bytes read or -1 if an error occurs.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK TCP socket server class.

This class provides a uniform cross-platform TCP socket server interface. Methods are provided for reading or writing data buffers to/from connections.

TCP sockets are reliable and connection-oriented. A TCP socket server must accept a connection from a TCP client before data can be sent or received. Data delivery is guaranteed in order, without loss, error, or duplication. That said, TCP transmissions tend to be slower than those using the UDP protocol and data sent with multiple write() calls can be arbitrarily combined by the underlying system.

The user is responsible for checking the values returned by the read/write methods. Values less than or equal to zero indicate a closed or lost connection or the occurence of an error.

by Perry R. Cook and Gary P. Scavone, 1995–2017.

## Constructor & Destructor Documentation

stk::TcpServer::TcpServer | ( | int | port = `2006` | ) |

Default constructor creates a local socket server on port 2006 (or the specified port number).

An StkError will be thrown if a socket error occurs during instantiation.

## Member Function Documentation

int stk::TcpServer::accept | ( | void |  | ) |

Extract the first pending connection request from the queue and create a new connection, returning the descriptor for the accepted socket.

If no connection requests are pending and the socket has not been set non-blocking, this function will block until a connection is present. If an error occurs, -1 is returned.

The documentation for this class was generated from the following file:

- TcpServer.h

The Synthesis ToolKit in C++ (STK)
©1995--2017 Perry R. Cook and Gary P. Scavone. All Rights Reserved.